package org.fortiss.af3.platform.raspberry.generator.executable.interfaces;

import org.fortiss.af3.deployment.model.Deployment;
import org.fortiss.af3.expression.model.terms.IExpressionTerm;

/**
 * Interface implemented by platform-specific executables, which need
 * termination when system goes down.
 * 
 * @author zverlov
 * @author $Author: zverlov $
 * @version $Rev: 4114 $
 * @ConQAT.Rating GREEN Hash: 9CD3B3AB64293053C6EE40AEED83A686
 */
public interface ITermExecutable {

	/**
	 * Returns an termination term of the platform-specific executable. Usually
	 * a function call to the hardware abstraction layer is returned here.
	 */
	public abstract IExpressionTerm getTermination(IExpressionTerm signal);

	/**
	 * @param depl
	 * @return
	 */
	IExpressionTerm getTermination(Deployment depl);

	/**
	 * @return
	 */
	IExpressionTerm getTermination();
}
